
const DBus = imports.dbus;
const Lang = imports.lang;
const St = imports.gi.St;
const Shell = imports.gi.Shell;
const Gio = imports.gi.Gio;
const Main = imports.ui.main;
const PopupMenu = imports.ui.popupMenu;
const Util = imports.misc.util;
const GLib = imports.gi.GLib;
const GnomeSession = imports.misc.gnomeSession;
const VolumeMenu = imports.ui.status.volume;
// CHANGE THE LINES 'const SEPERATOR, const VOLUME...' etc ONLY, to true or false!!!
//options are true to show and false to not show, you must already have installed the programs for this to run them
//try: sudo apt install pavucontrol paprefs pavumeter pulseaudio-equalizer paman
const POPUP_MENU = true; //adds shortcuts to popup menu on volume/sound menu
const POPUP_MENU_TEXT = "PulseAudio Settings"; //changes the text for the pop-up menu, default is PulseAudio Settings
const SEPERATOR = true;   //Shows a shiny seperator before the shortcuts, doesnt work with popup menu
const CUSTOM = true;   //Shows or hides the custom shortcut below(custom_command). The text shown can be modified below at 'CUSTOM_TEXT'.
const CUSTOM_TEXT = "Q Equalizer"; //the custom text for the custom_command below, this is just to change the text of the launcher
const CUSTOM_COMMAND = "qpaeq";   //Runs specified command, i.e by default it runs qpaeq which is a front-end for the newer module-equalizer-sink
const VOLUME = true;   //Runs PA Volume Control PA=Pulse Audio
const PREFS = true;   //Runs PA Preferences
const VUMETER = true;   //Runs PA VU Meter
const EQUALIZER = true;   //Runs the PA 'System-Wide' Equalizer.
const MANAGER = true;   //Starts the PA Manager, which can be used to restart pulse audio.
const PULSEAUDIO_TEXT = "PulseAudio "; //Optionally hide/change/remove the PulseAudio text, hint:add space at end if using text and must be "quoted" always!.
//DONT DO NOT touch anything below this line

let itemSeperator, paCustom2, paVolume2, paPrefs2, paVumeter2, paEqualizer2, paManager2, pulseMenu2, pulseMenu, nItems;

function _onCustomApp() {
    let app = Util.spawn([CUSTOM_COMMAND]);
    app.activate();
}
function init() {
}
function enable() {
                    if (POPUP_MENU) {
        pulseMenu2 = Main.panel._statusArea.volume;
        pulseMenu = new PopupMenu.PopupSubMenuMenuItem(_(POPUP_MENU_TEXT));
        pulseMenu2.menu.addMenuItem(pulseMenu, pulseMenu2.menu.numMenuItems - 1);
        nItems = pulseMenu2.menu.numMenuItems;
                    } else {
        pulseMenu = Main.panel._statusArea.volume;
        nItems = pulseMenu.menu.numMenuItems;
                    }
                    if (SEPERATOR) {
        itemSeparator = new PopupMenu.PopupSeparatorMenuItem();
        pulseMenu.menu.addMenuItem(itemSeparator, nItems - 3);
                    }
                    if (CUSTOM) {
        paCustom2 = new PopupMenu.PopupMenuItem(_(CUSTOM_TEXT), 0);
        paCustom2.connect('activate', Lang.bind(paCustom2, _onCustomApp));
        pulseMenu.menu.addMenuItem(paCustom2, nItems - 2);
                    }
                    if (VOLUME) {
        paVolume2 = pulseMenu.menu.addSettingsAction(_(PULSEAUDIO_TEXT + "Volume Control"), 'pavucontrol.desktop', 0);
        pulseMenu.menu.addMenuItem(paVolume2, nItems - 2);
                    }
                    if (PREFS) {
        paPrefs2 = pulseMenu.menu.addSettingsAction(_(PULSEAUDIO_TEXT + "Preferences"), 'paprefs.desktop', 0);
        pulseMenu.menu.addMenuItem(paPrefs2, nItems - 2);
                    }
                    if (VUMETER) {
        paVumeter2 = pulseMenu.menu.addSettingsAction(_(PULSEAUDIO_TEXT + "Volume Meter"), 'pavumeter.desktop', 0);
        pulseMenu.menu.addMenuItem(paVumeter2, nItems - 2);
                    }
                    if (EQUALIZER) {
        paEqualizer2 = pulseMenu.menu.addSettingsAction(_(PULSEAUDIO_TEXT + "Equalizer"), 'pulseaudio-equalizer.desktop', 0);
        pulseMenu.menu.addMenuItem(paEqualizer2, nItems - 2);
                    }
                    if (MANAGER) {
        paManager2 = pulseMenu.menu.addSettingsAction(_(PULSEAUDIO_TEXT + "Manager"), 'paman.desktop', 0);
        pulseMenu.menu.addMenuItem(paManager2, nItems - 2);
                    }
}
function disable() {
                    if (SEPERATOR) {
        itemSeparator.destroy();
                    }
                    if (POPUP_MENU) {
        pulseMenu.destroy();
                    } 
                    if (!POPUP_MENU && paCustom2) {
        paCustom2.destroy();
                    }
                    if (!POPUP_MENU && paVolume2) {
        paVolume2.destroy();
                    }
                    if (!POPUP_MENU && paPrefs2) {
        paPrefs2.destroy();
                    }
                    if (!POPUP_MENU && paVumeter2) {
        paVumeter2.destroy();
                    }
                    if (!POPUP_MENU && paEqualizer2) {
        paEqualizer2.destroy();
                    }
                    if (!POPUP_MENU && paManager2) {
        paManager2.destroy();
                    }
}
